package com.css.simulation.resource.model.service;

import api.common.pojo.vo.model.VehicleDefaultValueVO;
import api.common.pojo.vo.model.VehicleTempVO;
import api.common.util.ObjectUtil;
import com.css.simulation.resource.model.mapper.VehicleTempMapper;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.HashMap;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

@Service
public class VehicleTempService {


    @Autowired
    VehicleTempMapper vehicleTempMapper;

    public Object getVehicleTempTree() {
        List<VehicleTempVO> list = vehicleTempMapper.getVehicleTempTree();
        List<Object> treeList = new LinkedList<>();
        Map<String, List<VehicleTempVO>> typeCollect = list.stream().collect(Collectors.groupingBy(VehicleTempVO::getVehicleType));
        typeCollect.forEach((typeKey,typeValue)->{
            Map typeMap = new HashMap();
            typeMap.put("code",typeKey);
            typeMap.put("name",typeValue.get(0).getVehicleName());
            List<Object> modelList = new LinkedList();
            Map<String, List<VehicleTempVO>> modelCollect = typeValue.stream().collect(Collectors.groupingBy(VehicleTempVO::getVehicleModel));
            modelCollect.forEach((modelKey,modelValue)->{
                Map modelMap = new HashMap();
                modelMap.put("code",modelKey);
                modelMap.put("name",modelKey);
                List<Object> colourList = new LinkedList();
                modelValue.forEach(vo->{
                    Map colourMap = new HashMap();
                    colourMap.put("code",vo.getVehicleColour());
                    colourMap.put("name",vo.getVehicleColour());
                    VehicleDefaultValueVO defaultValueVO = new VehicleDefaultValueVO();
                    ObjectUtil.voToPo(vo,defaultValueVO);
                    colourMap.put("vo",defaultValueVO);
                    colourList.add(colourMap);
                });
                modelMap.put("children",colourList);
                modelList.add(modelMap);
            });
            typeMap.put("children",modelList);
            treeList.add(typeMap);
        });
        return treeList;
    }
}
